mod Ex05a logic: 'cl'

incl Mtex

incl Mtexg

incl Mauxa

loc rem 
  \para \bf  5. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.16 
  \para* \it  Datum:  \end stvrtok 22.3.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INAA-046-svp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii s mierou 
  a chvostovej rekurzii. 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Course of values recursive definitions.  \end 

rem 
  \para \bf  Complete mathematical induction.  \end Show that the principle of 
  complete mathematical induction is admissible in Peano arithmetic. 
  \para \it  Hint.  \end Reduce complete induction to mathematical induction as 
  described in Sect. 7.3 of [1], pg. 187. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Complete_mathematical_induction

pred A 'Tex_p1_phi_subst'

axiom Progressivity
  \a x(\a y(y < x -> A(y)) -> A(x))

thm Conclusion
  A(x)

end theory Complete_mathematical_induction

rem 
  \para \bf  [CL] Complete mathematical induction.  \end Syntax: 
  \eq* 
    'indm <variable> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_indm(x) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                                           Tex_f2_g_imp(Tex_f2_g_lt(y,
                                                                                                                    x),
                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                    y))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       x)),
                                              Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                           x)),
                            Tex_f0_g_x_nothing)
         \end
   \item \para \ft Tex_f1_g_x_indm Tex_f2_g_x_sc(x,a,b) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                                           Tex_f2_g_imp(Tex_f2_g_lt(y,
                                                                                                                    x),
                                                                                                        Tex_f2_g_forall(a,
                                                                                                                        Tex_f2_g_forall(b,
                                                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                                                    y))))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       x)),
                                              Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                           x)),
                            Tex_f0_g_x_nothing)
         \end
  \end

rem 
  \para \bf  Integer division.  \end 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = 0 <- y != 0 & x < y
  Div(x,y) = Div(x-y,y)+1 <- y != 0 & x >= y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    y != 0 -> \e r(x = Div(x,y)*y+r & r < y)
  \end

thm Spec_div
  y != 0 -> \e r(x = Div(x,y)*y+r & r < y)

rem 
  \para \bf  Greatest common divisor.  \end 

fun/2 Gcd1 'Tex_f2_n_gcd'
  Gcd1(x,0) = x
  Gcd1(x,y) = Gcd1(y,x mod y) <- y != 0

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 \/ y != 0 -> Divides(Gcd1(x,y),x) & Divides(Gcd1(x,y),y)
  \end
  \eq* 
    (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd1(x,y)
  \end
  \para \it  Hint.  \end See the theorems \it  Remainder_mod  \end and \it  
  Divides_mod  \end in the module \it  Mauxa  \end. 

thm Spec_gcd_divides1
  x != 0 \/ y != 0 -> Divides(Gcd1(x,y),x) & Divides(Gcd1(x,y),y)

thm Spec_gcd_greatest1
  (x != 0 \/ y != 0) & Divides(z,x) & Divides(z,y) -> z <= Gcd1(x,y)

rem 
  \para \bf  Course of values recursive definitions with measure.  \end 

rem 
  \para \bf  Course of values induction with measure.  \end Show that the 
  principle of course of values induction with measure is admissible in Peano 
  arithmetic. 
  \para \it  Hint.  \end Reduce measure induction to mathematical induction as 
  described in Sect. 8.4 of [1], pg. 243. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Course_of_values_induction_with_measure

fun M1 'Tex_f1_mu_subst'

pred A 'Tex_p1_phi_subst'

axiom Progressivity
  \a x(\a y(M1(y) < M1(x) -> A(y)) -> A(x))

thm Conclusion
  A(x)

end theory Course_of_values_induction_with_measure

rem 
  \para \bf  [CL] Course of values induction with measure.  \end Syntax: 
  \eq* 
    'indm <measure> [; <variable(s)>]'
  \end
  \para where the induction formula is formed from the current sequent. 
  \para Example(s): 
  \items 
   \item \para \ft Tex_f1_g_x_indm Tex2_bappl1(Tex0_mu,x) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                                           Tex_f2_g_imp(Tex_f2_g_lt(Tex2_bappl1(Tex0_mu,
                                                                                                                                y),
                                                                                                                    Tex2_bappl1(Tex0_mu,
                                                                                                                                x)),
                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                    y))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       x)),
                                              Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                           x)),
                            Tex_f0_g_x_nothing)
         \end
   \item \para 
         \ft Tex_f1_g_x_indm Tex_f2_g_x_sc(Tex2_bappl1(Tex0_mu,x),a,b) \end 
         \eq* 
           Tex_f3_g_x_nrule(Tex_f0_g_x_nothing,
                            Tex_f2_g_x_branch(Tex_f1_g_x_goal Tex_f2_g_imp(Tex_f2_g_forall(y,
                                                                                           Tex_f2_g_imp(Tex_f2_g_lt(Tex2_bappl1(Tex0_mu,
                                                                                                                                y),
                                                                                                                    Tex2_bappl1(Tex0_mu,
                                                                                                                                x)),
                                                                                                        Tex_f2_g_forall(a,
                                                                                                                        Tex_f2_g_forall(b,
                                                                                                                                        Tex2_bappl1(Tex0_phi,
                                                                                                                                                    y))))),
                                                                           Tex2_bappl1(Tex0_phi,
                                                                                       x)),
                                              Tex_f1_g_x_assum Tex2_bappl1(Tex0_phi,
                                                                           x)),
                            Tex_f0_g_x_nothing)
         \end
  \end

rem 
  \para \bf  Greatest common divisor.  \end 

fun/2 Gcd2 'Tex_f2_n_gcd'
  Gcd2(x,y) = Gcd2(x,y-x) <- x != 0 & y != 0 & x < y
  Gcd2(x,y) = x <- x != 0 & y != 0 & x = y
  Gcd2(x,y) = Gcd2(x-y,y) <- x != 0 & y != 0 & x > y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 & y != 0 -> Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)
  \end
  \eq* 
    x != 0 & y != 0 & Divides(z,x) & Divides(z,y) -> z <= Gcd2(x,y)
  \end

thm Spec_gcd_divides2
  x != 0 & y != 0 -> Divides(Gcd2(x,y),x) & Divides(Gcd2(x,y),y)

thm Spec_gcd_greatest2
  x != 0 & y != 0 & Divides(z,x) & Divides(z,y) -> z <= Gcd2(x,y)

